/*
Copyright (C) September 1999, Ka-Ping Yee

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#include "dynim.h"

#include <fcntl.h>

byte sc(byte orig, byte filt)
    {
    return 255 - (((long) 255 - orig) * ((long) 255 - filt) / 255);
    }

int main(int argc, char** argv)
    {
    DynImCanvas* fc;
    DynImFont* font;
    DynImCanvas* canvas;
    DynImBuffer* buffer = 0;
    DynImCanvas* blank;
    DynImBuffer* blankbuffer;
    int i, x, y;
    char line[1000];
    int r, g, b;

    i = open("font.ppm", O_RDONLY);
    fc = dynim_canvas_loadppm(i);
    font = dynim_font_newfromcanvas(fc);

    canvas = dynim_canvas_new(dynim_palette_clone(fc->palette), 400, 11);
    dynim_canvas_clear(canvas, 0);

    blank = dynim_canvas_new(fc->palette, 400, 11);
    dynim_canvas_clear(blank, 0);
    blankbuffer = dynim_gif_encode(blank);

    x = 0;
    y = 0;

    dynim_gif_start(1, 400, 330);
    dynim_gif_putcomment(1, "generated by libdynim version 1.0");

    fflush(stdout);

    while (fgets(line, 999, stdin))
        {
        sscanf(line, "%02x %02x %02x", &r, &g, &b);
        for (i=0; i < canvas->palette->size; i++)
            {
            canvas->palette->colours[i].r = sc(fc->palette->colours[i].r, r);
            canvas->palette->colours[i].g = sc(fc->palette->colours[i].g, g);
            canvas->palette->colours[i].b = sc(fc->palette->colours[i].b, b);
            }
        
        dynim_canvas_clear(canvas, 0);
        dynim_canvas_drawtext(canvas, font, line + 9, 0, 9, 0);
        if (buffer) dynim_buffer_delete(buffer);
        buffer = dynim_gif_encode(canvas);

        dynim_gif_putcanvas(1, canvas, buffer, x, y);
        y += 11;
        if (y > 319) y = 0;
        dynim_gif_putcanvas(1, blank, blankbuffer, x, y);
        fflush(stdout);
        }

    dynim_gif_end(1);
    return 0;
    }
