/*
Copyright (C) September 1999, Ka-Ping Yee

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#include "dynim.h"

/* DynImPalette ======================================================== */

/* -------------------------------------------------------- construction */
DynImPalette* dynim_palette_new(int size)
    {
    DynImPalette* palette = alloc(DynImPalette);
    palette->size = size;
    palette->colours = allocarray(DynImColour, size);
    return palette;
    }

void dynim_palette_delete(DynImPalette* palette)
    {
    toast(palette->colours);
    toast(palette);
    }


/* ------------------------------------------------------------- cloning */
DynImPalette* dynim_palette_clone(DynImPalette* source)
    {
    DynImPalette* palette = dynim_palette_new(source->size);
    memcpy(palette->colours, source->colours,
           source->size * sizeof(DynImColour));
    return palette;
    }
