/*
Copyright (C) September 1999, Ka-Ping Yee

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#ifndef TABLE_H
#define TABLE_H

#include "dynim.h"

struct TableEntry
    {
    byte* key;
    int size;
    int value;
    word hash;
    struct TableEntry* next;
    };

typedef struct TableEntry TableEntry;

typedef struct
    {
    int nbuckets;
    TableEntry** buckets;
    }
Table;

Table* table_new(int nbuckets);
void table_delete(Table* table);
void table_clear(Table* table);
word table_hash(byte* key, int size);
void table_put(Table* table, byte* key, int size, int value);
int table_get(Table* table, byte* key, int size);

#endif
