/*
Copyright (C) September 1999, Ka-Ping Yee

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#include "dynim.h"

#include <fcntl.h>

int main(int argc, char** argv)
    {
    DynImCanvas* fc;
    DynImFont* font;
    DynImPalette* palette;
    DynImCanvas* canvas;
    DynImBuffer* buffer;
    int i;

    i = open("font.ppm", O_RDONLY);
    fc = dynim_canvas_loadppm(i);
    font = dynim_font_newfromcanvas(fc);

    canvas = dynim_canvas_new(fc->palette, 100, 100);
    dynim_canvas_drawtext(canvas, font, "I say, i say, i say!", 10, 20, 0);

    buffer = dynim_gif_encode(canvas);
    dynim_gif_start(1, 100, 100);
    dynim_gif_putcomment(1, "generated by libdynim version 1.0");
    dynim_gif_putcanvas(1, canvas, buffer, 0, 0);
    dynim_gif_end(1);

/*
    srand(time());
    palette = dynim_palette_new(64);
    for (i = 0; i < 64; i++)
        {
        palette->colours[i].r = random() % 256;
        palette->colours[i].g = random() % 256;
        palette->colours[i].b = random() % 256;
        }
    canvas = dynim_canvas_new(palette, 20, 20);
    for (i = 0; i < 100; i++)
        {
        dynim_canvas_drawrect(canvas, random() % 20, random() % 20,
                                      random() % 20, random() % 20,
                                      random() % 64);
        }

    buffer = dynim_gif_encode(canvas);

    dynim_gif_start(1, 100, 100);
    dynim_gif_putcomment(1, "generated by libdynim version 1.0");
    for (i = 0; i < 100; i++)
        {
        dynim_gif_putcanvas(1, canvas, buffer, random() % 80, random() % 80);
        }
    dynim_gif_end(1);
*/
    return 0;
    }
